/*
 * This file was automaticly generated by clo++ version 0.6.4 (REL-0_6_4)
 * http://pmade.org/pjones/software/clo++/
 */

/** @file
 * This file contains the implementation of the parser class.
 * You can control the name of this source file using the
 * cxx_source_file variable.
**/

#include "Options.h"
#include <cstring>
#include <cstdlib>
#include <cctype>

namespace {
    const char const_usage[] =
"  -a, --all                        Generate statistics for all numerical\n"
"                                   columns.\n"
"  -b, -g, --break, --group string  Set the group column(s) to the specified\n"
"                                   column name(s). Consecutive rows with\n"
"                                   the same value in the group column(s)\n"
"                                   are treated as independent data sets.\n"
"                                   This option cannot be used in conjunction-\n"
"                                    with the --rows option. This option may\n"
"                                   be repeated.\n"
"  -d string                        Override the column type definition for\n"
"                                   specified column in the rdb file.\n"
"  -i, --input string               Input RDB file.\n"
"  -n, --normalize enum             This specifies that the output\n"
"                                   statistics should be normalized either\n"
"                                   by the median or the average. If\n"
"                                   'median' is specified, the --quartiles\n"
"                                   option is implicitly turned on unless --\n"
"                                   percentiles is specified.\n"
"  -o, --output string              Output RDB file.\n"
"  -p, --percentiles string         Generate percentile statistics,\n"
"                                   including the median, as well as the\n"
"                                   normal statistics. The percentile list\n"
"                                   is a comma separated list of percentages.-\n"
"                                    Because all of the data must be stored\n"
"                                   in memory for all of the columns for\n"
"                                   these statistics, this is a rather\n"
"                                   memory intensive option for large data\n"
"                                   sets\n"
"  -q, --quartiles                  Generate quartile statistics (first and\n"
"                                   last quartile and median) as well as the\n"
"                                   normal statistics. Because all of the\n"
"                                   data must be stored in memory for all of\n"
"                                   the columns for these statistics, this\n"
"                                   is a rather memory intensive option for\n"
"                                   large data sets.\n"
"  -r, --rows string                Specify the ranges of rows to operate\n"
"                                   on. This option may be used multiple\n"
"                                   times. This option cannot be used in\n"
"                                   conjunction with the --group option.\n"
"  -u, --usage                      print a detailed help then exit\n"
"  -v, --version                    print the program version then exit\n";

    const char const_help_comment[] =
"use the -h option for help";

    const char* expand_long_name (const std::string &name);
}

//#########################################################################
clo::parser::parser (void)
    : state_(state_option)
{
    std::memset(&locations_, 0, sizeof(locations_));
}
//#########################################################################
void clo::parser::parse (int argc, char *argv[], bool call_finalize) {
    for (int i=1; i<argc; ++i) parse_element(argv[i], i, source_cl);
    if (call_finalize) finalize();
}
//#########################################################################
void clo::parser::finalize (void) {
    if (state_ == state_value) {
	switch (openum_) {
	    case option_all:
		throw option_error("missing value for 'all' option");
	    case option_group:
		throw option_error("missing value for 'group' option");
	    case option_input:
		throw option_error("missing value for 'input' option");
	    case option_normalize:
		throw option_error("missing value for 'normalize' option");
	    case option_output:
		throw option_error("missing value for 'output' option");
	    case option_override:
		throw option_error("missing value for 'd' option");
	    case option_percentiles:
		throw option_error("missing value for 'percentiles' option");
	    case option_quartiles:
		throw option_error("missing value for 'quartiles' option");
	    case option_rows:
		throw option_error("missing value for 'rows' option");
	    case option_usage:
		throw option_error("missing value for 'usage' option");
	    case option_version:
		throw option_error("missing value for 'version' option");
	}

    }

}
//#########################################################################
void clo::parser::parse_element (const char *element, int position, opsource source) {
    std::size_t length = std::strlen(element);

    switch (state_) {
	case state_consume:
	    non_options_.push_back(element);
	    break;
	case state_option:
	    if (length >= 2 && element[0] == '-' && element[1] == '-') {
		if (length == 2) { state_ = state_consume; return; }
		element += 2;
		const char *value = element;
		while (*value != 0 && *value != '=') ++value;
		if (*value == '=') {
		    std::string selement(element, value - element), svalue(++value);

		    parse_long_option(selement.c_str(), position, source);
		    if (state_ != state_value) {
			std::string error("the '"); error += element; error += "' option does not take a value";
			throw option_error(error);
		    }

		    parse_value(svalue.c_str());
		    state_ = state_option;
		} else {
		    parse_long_option(element, position, source);
		}
	    } else if (length >= 2 && element[0] == '-') {
		++element;

		if (length > 2) {
		    while (*element != 0) {
			parse_short_option(*element, position, source);
			++element;
	    
			if (state_ == state_value && *element != 0) {
			    parse_value(element);
			    state_ = state_option;
			    break;
			}
		    }
		} else {
		    parse_short_option(*element, position, source);
		}
	    } else {
		non_options_.push_back(element);
	    }
	    break;
	case state_value:
	    parse_value(element);
	    state_ = state_option;
	    break;
    }
}
//#########################################################################
void clo::parser::parse_short_option (char option, int position, opsource source) {
    switch (option) {
    	case 'a':
    	    source = source; // kill compiler unused variable warning
    	    if (locations_.all) {
    		throw option_error("the 'all' option is only allowed once");
    	    }
    	    openum_ = option_all;
    	    options_.all = !options_.all;
    	    locations_.all = position;
    	    return;
    	case 'b':
    	    source = source; // kill compiler unused variable warning
    	    openum_ = option_group;
    	    state_ = state_value;
    	    locations_.group = position;
    	    return;
    	case 'd':
    	    source = source; // kill compiler unused variable warning
    	    openum_ = option_override;
    	    state_ = state_value;
    	    locations_.override = position;
    	    return;
    	case 'g':
    	    source = source; // kill compiler unused variable warning
    	    openum_ = option_group;
    	    state_ = state_value;
    	    locations_.group = position;
    	    return;
    	case 'i':
    	    source = source; // kill compiler unused variable warning
    	    openum_ = option_input;
    	    state_ = state_value;
    	    locations_.input = position;
    	    return;
    	case 'n':
    	    source = source; // kill compiler unused variable warning
    	    if (locations_.normalize) {
    		throw option_error("the 'normalize' option is only allowed once");
    	    }
    	    openum_ = option_normalize;
    	    state_ = state_value;
    	    locations_.normalize = position;
    	    return;
    	case 'o':
    	    source = source; // kill compiler unused variable warning
    	    openum_ = option_output;
    	    state_ = state_value;
    	    locations_.output = position;
    	    return;
    	case 'p':
    	    source = source; // kill compiler unused variable warning
    	    if (locations_.percentiles) {
    		throw option_error("the 'percentiles' option is only allowed once");
    	    }
    	    openum_ = option_percentiles;
    	    state_ = state_value;
    	    locations_.percentiles = position;
    	    return;
    	case 'q':
    	    source = source; // kill compiler unused variable warning
    	    if (locations_.quartiles) {
    		throw option_error("the 'quartiles' option is only allowed once");
    	    }
    	    openum_ = option_quartiles;
    	    options_.quartiles = !options_.quartiles;
    	    locations_.quartiles = position;
    	    return;
    	case 'r':
    	    source = source; // kill compiler unused variable warning
    	    openum_ = option_rows;
    	    state_ = state_value;
    	    locations_.rows = position;
    	    return;
    	case 'u':
    	    source = source; // kill compiler unused variable warning
    	    throw autoexcept(autothrow_usage, "usage");
    	case 'v':
    	    source = source; // kill compiler unused variable warning
    	    throw autoexcept(autothrow_version, "version");
    	case 'h':
    	    if (source != source_cl) break;
    	    throw autoexcept(autothrow_help, const_usage);
    	case '?':
    	    if (source != source_cl) break;
    	    throw autoexcept(autothrow_help, const_usage);
    }

    std::string error("unknown option: '"); error += option; error += "'";
    throw option_error(error);
}
//#########################################################################
void clo::parser::parse_long_option (const char *option, int position, opsource source) {
    option = expand_long_name(option);

	    if (std::strcmp(option, "all") == 0) {
		source = source; // kill compiler unused variable warning
		if (locations_.all) {
		    throw option_error("the 'all' option is only allowed once");
		}
		openum_ = option_all;
		locations_.all = position;
		options_.all = !options_.all;
		return;
	    } else if (std::strcmp(option, "break") == 0) {
		source = source; // kill compiler unused variable warning
		openum_ = option_group;
		locations_.group = position;
		state_ = state_value;
		return;
	    } else if (std::strcmp(option, "group") == 0) {
		source = source; // kill compiler unused variable warning
		openum_ = option_group;
		locations_.group = position;
		state_ = state_value;
		return;
	    } else if (std::strcmp(option, "input") == 0) {
		source = source; // kill compiler unused variable warning
		openum_ = option_input;
		locations_.input = position;
		state_ = state_value;
		return;
	    } else if (std::strcmp(option, "normalize") == 0) {
		source = source; // kill compiler unused variable warning
		if (locations_.normalize) {
		    throw option_error("the 'normalize' option is only allowed once");
		}
		openum_ = option_normalize;
		locations_.normalize = position;
		state_ = state_value;
		return;
	    } else if (std::strcmp(option, "output") == 0) {
		source = source; // kill compiler unused variable warning
		openum_ = option_output;
		locations_.output = position;
		state_ = state_value;
		return;
	    } else if (std::strcmp(option, "percentiles") == 0) {
		source = source; // kill compiler unused variable warning
		if (locations_.percentiles) {
		    throw option_error("the 'percentiles' option is only allowed once");
		}
		openum_ = option_percentiles;
		locations_.percentiles = position;
		state_ = state_value;
		return;
	    } else if (std::strcmp(option, "quartiles") == 0) {
		source = source; // kill compiler unused variable warning
		if (locations_.quartiles) {
		    throw option_error("the 'quartiles' option is only allowed once");
		}
		openum_ = option_quartiles;
		locations_.quartiles = position;
		options_.quartiles = !options_.quartiles;
		return;
	    } else if (std::strcmp(option, "rows") == 0) {
		source = source; // kill compiler unused variable warning
		openum_ = option_rows;
		locations_.rows = position;
		state_ = state_value;
		return;
	    } else if (std::strcmp(option, "usage") == 0) {
		source = source; // kill compiler unused variable warning
		throw autoexcept(autothrow_usage, "usage");
	    } else if (std::strcmp(option, "version") == 0) {
		source = source; // kill compiler unused variable warning
		throw autoexcept(autothrow_version, "version");
	    } else if (source == source_cl && std::strcmp(option, "help") == 0) {
		throw autoexcept(autothrow_help, const_usage);
	    }

    std::string error("unknown option '"); error += option; error += "'";
    throw option_error(error);
}
//#########################################################################
void clo::parser::parse_value (const char *value) {
    switch (openum_) {
    	case option_all:
    	    break;
    	case option_group:
    	    {
    		options_.group.push_back(value);
    	    }
    	    break;
    	case option_input:
    	    {
    		options_.input = value;
    	    }
    	    break;
    	case option_normalize:
    	    {
    		normalize_enum evalue;

    		if (std::strcmp(value, "ave") == 0) {
    		    evalue = normalize_ave;
    		} else if (std::strcmp(value, "median") == 0) {
    		    evalue = normalize_med;
    		} else if (std::strcmp(value, "none") == 0) {
    		    evalue = normalize_none;
    		} else {
    		    std::string error("'"); error += value; error += "' is an invalid value for the 'normalize' option";
    		    throw option_error(error);
    		}

    		options_.normalize = evalue;
    	    }
    	    break;
    	case option_output:
    	    {
    		options_.output = value;
    	    }
    	    break;
    	case option_override:
    	    {
    		options_.override.push_back(value);
    	    }
    	    break;
    	case option_percentiles:
    	    {
    		options_.percentiles = value;
    	    }
    	    break;
    	case option_quartiles:
    	    break;
    	case option_rows:
    	    {
    		options_.rows.push_back(value);
    	    }
    	    break;
    	case option_usage:
    	    break;
    	case option_version:
    	    break;
    }
}
//#########################################################################
const char* clo::option_error::get_help_comment (void) const {
    return const_help_comment;
}
//#########################################################################
namespace {
    const char* expand_long_name (const std::string &name) {
	std::string::size_type name_size = name.size();
	std::vector<const char*> matches;

        if (name_size <= 3 && name.compare(0, name_size, "all", name_size) == 0)
        	matches.push_back("all");

        if (name_size <= 5 && name.compare(0, name_size, "break", name_size) == 0)
        	matches.push_back("break");

        if (name_size <= 5 && name.compare(0, name_size, "group", name_size) == 0)
        	matches.push_back("group");

        if (name_size <= 5 && name.compare(0, name_size, "input", name_size) == 0)
        	matches.push_back("input");

        if (name_size <= 9 && name.compare(0, name_size, "normalize", name_size) == 0)
        	matches.push_back("normalize");

        if (name_size <= 6 && name.compare(0, name_size, "output", name_size) == 0)
        	matches.push_back("output");

        if (name_size <= 11 && name.compare(0, name_size, "percentiles", name_size) == 0)
        	matches.push_back("percentiles");

        if (name_size <= 9 && name.compare(0, name_size, "quartiles", name_size) == 0)
        	matches.push_back("quartiles");

        if (name_size <= 4 && name.compare(0, name_size, "rows", name_size) == 0)
        	matches.push_back("rows");

        if (name_size <= 5 && name.compare(0, name_size, "usage", name_size) == 0)
        	matches.push_back("usage");

        if (name_size <= 7 && name.compare(0, name_size, "version", name_size) == 0)
        	matches.push_back("version");

        if (name_size <= 4 && name.compare(0, name_size, "help", name_size) == 0)
        	matches.push_back("help");


	if (matches.empty()) {
	    std::string error("unknown option '"); error += name; error += "'";
	    throw clo::option_error(error);
	}

	if (matches.size() == 1) {
	    return matches[0];
	}

	std::string error("the option name '"); error += name; error += "' is ambiguous";
	throw clo::option_error(error);
    }
} // end anonymous namespace
