// File:  RdbStatsPercentilesAve.cc

// --8<--8<--8<--8<--
//
// Copyright (C) 2006 Smithsonian Astrophysical Observatory
//
// This file is part of rdbstats
//
// rdbstats is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// rdbstats is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the 
//       Free Software Foundation, Inc. 
//       51 Franklin Street, Fifth Floor
//       Boston, MA  02110-1301, USA
//
// -->8-->8-->8-->8--

#include "RdbStatsPercentilesAve.h"

// The user specified percentiles.  For example: --percentiles 12,34,45
RdbStatsPercentilesAve::RdbStatsPercentilesAve( RDB& irdbtable,
						const string& name,
						const string& percent_list,
						bool implicitquartile )
  throw( Exception ) try : RdbStatsPercentiles( irdbtable, name,
						percent_list,
						implicitquartile ) {

    try {

#ifdef TRACEFCT
      TraceFct tf( "RdbStatsPercentilesAve::RdbStatsPercentilesAve( RDB&, "
		   "const string&, const string& ) throw( Exception )" );
#endif

    } catch ( Exception& E ) {

      throw;

    } catch ( exception& e ) {

      throw Exception( e.what( ) );

    }

  } catch ( Exception& E ) {

    // exception thrown by RdbStatsPercentiles class is caught here
    throw;

  } catch ( exception& e ) {

    // exception thrown by RdbStatsPercentiles class is caught here
    throw Exception( e.what( ) );

  }

// --quartiles was entered at the command line.
RdbStatsPercentilesAve::RdbStatsPercentilesAve( RDB& irdbtable,
						const string& name )
  throw( Exception ) try : RdbStatsPercentiles( irdbtable, name ) {

    try {

#ifdef TRACEFCT
      TraceFct tf( "RdbStatsPercentilesAve::RdbStatsPercentilesAve( RDB&, "
		   "const string&, const string& ) throw( Exception )" );
#endif

    } catch ( Exception& E ) {

      throw;

    } catch ( exception& e ) {

      throw Exception( e.what( ) );

    }

  } catch ( Exception& E ) {

    // exception thrown by RdbStatsPercentiles class is caught here
    throw;

  } catch ( exception& e ) {

    // exception thrown by RdbStatsPercentiles class is caught here
    throw Exception( e.what( ) );

  }

int RdbStatsPercentilesAve::calculate_statistics( ) throw( ) {

#ifdef TRACEFCT
  TraceFct tf( "double RdbStatsPercentilesAve::calculate_statistics( ) "
	       "throw( )" );
#endif

  // calculate the regular-stats and the percentiles.
  if ( 0 == this->RdbStatsPercentiles::calculate_statistics( ) )
    return 0;

  // normalize the result wrt the average.
  double norm_factor = get_absolute_average( );
  normalize_results( norm_factor );

  return num_n;

}
