#ifndef Row_H
#define Row_H

/* --8<--8<--8<--8<--
 *
 * Copyright (C) 2006 Smithsonian Astrophysical Observatory
 *
 * This file is part of rdbstats
 *
 * rdbstats is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * rdbstats is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the 
 *       Free Software Foundation, Inc. 
 *       51 Franklin Street, Fifth Floor
 *       Boston, MA  02110-1301, USA
 *
 * -->8-->8-->8-->8-- */

#include <vector>

class Exception;

using namespace std;

class Row {

  friend ostream& operator << ( ostream& os, Row& a ) {
    a.print( os );
    return os;
  }

  friend ostream& operator << ( ostream& os, Row* a ) {
    a->print( os );
    return os;
  }

public:

  ~Row( ) { }

  Row( const vector< string >& row_options ) throw ( Exception );

  const vector< pair< long, long > >& get_range( ) { return start_end; }

private:

  void print( ostream& os ) const;

  vector< pair< long, long > > start_end;

};

#endif
